<?php
//
// +----------------------------------------------------------------------+
// | PHP Version 5                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997-2003 The PHP Group                                |
// +----------------------------------------------------------------------+
// | This source file is subject to version 3.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/3_0.txt.                                  |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Hartmut Holzgraefe <hholzgra@php.net>                       |
// +----------------------------------------------------------------------+
//
// $Id: Release.php,v 1.2 2004/06/14 11:47:54 hholzgra Exp $
//

class PECL_Gen_Release extends PEAR
{
	/**
	 * The current version number 
	 *
	 * @access private
	 * @var     string
	 */
	var $version = "0.0.7";
	
	/**
	 * Set method for version number
	 *
	 * @access public
	 * @param  string version
	 * @return bool   true on success
	 */
	function set_version($version) 
	{
		// TODO check format
		$this->version = $version;
		
		return true;
	}
	



	/**
	 * The release date
	 *
	 * @access private
	 * @var     string
	 */
	var $date = "";
	
	/**
	 * Set method for release date
	 *
	 * @access public
	 * @param  int    timestamp
	 * @return bool   true on success
	 */
	function set_date($date)
	{
		// TODO parse date if not numeric
		// TODO check valid dates
		$this->date = $date;
		
		return true;
	}
	





	/**
	 * The 'state': alpha, beta, stable, dev ...
	 *
	 * @access private
	 * @var     string
	 */
	var $state = "unknown";
	
	/**
	 * Set method for state
	 *
	 * @access public
	 * @param  string state
	 * @return bool   true on success
	 */
	function set_state($state)
    {
		// TODO check valid states
		$this->state = $state;
		
		return true;
	}




	/**
	 * Release notes
	 *
	 * @access private
	 * @var     string
	 */
	var $notes = "";


	/**
	 * Set method for release notes
	 *
	 * @access public
	 * @param  string release notes
	 * @return bool   true on success
	 */
	function set_notes($notes)
    {
		$this->notes = $notes;
		
		return true;
	}
	
	



	/**
	 * Constructor
	 *
	 * @access public
	 */
    function __construct()
	{
		$this->date = date("Y-m-d");
	}
  



	/**
	 * generate XML fragment for package.xml
	 *
	 * @access public
	 * @return string XML fragment
	 */
	function package_xml()
    {
		$code = "\n  <release>\n";
		foreach (array("version", "date", "state", "notes") as $key) {
			if ($this->$key !== "") {
				$code.= "    <$key>{$this->$key}</$key>\n";
			}
		}
		$code.= "  </release>\n";
		
		return $code;
	}

}

?>